
#ifndef __SCENELIGHT_H_
#define __SCENELIGHT_H_
/*
Peon - Win32 Games Programming Library
Copyright (C) 2002-2005 Erik Yuzwa

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Erik Yuzwa
peon AT wazooinc DOT com
*/


#include "ISceneObject.h"
#include "Vector4.h"

namespace peon
{
	/**
	* This object acts as a crude container for our lighting modes we wish
	* to inject into the graphics pipeline. We just need to set a few properties,
	* and feed it into the SceneRenderer to take effect.
	*/
	class PEONMAIN_API SceneLight : public ISceneObject
	{
	public:
		/** our ambient light setting */
		Vector4 m_vecAmbient;

		/** our diffuse light setting */
		Vector4 m_vecDiffuse;

		/** our light position..most often also the direction of the light*/
		Vector4 m_vecDirection;

	public:
		/**
		* Constructor
		*/
		SceneLight();

		/**
		* Destructor
		*/
		~SceneLight();
	};
}

#endif
