
#include "SceneRoot.h"

namespace peon
{
	template<> SceneRoot* ISingleton<SceneRoot>::ms_Singleton = 0;

	SceneRoot* SceneRoot::getSingletonPtr(void)
	{
		return ms_Singleton;
	}

	SceneRoot& SceneRoot::getSingleton(void)
	{  
		assert( ms_Singleton );  
		return ( *ms_Singleton ); 

	}


	SceneRoot::SceneRoot( SceneRenderer* pRenderer ) : m_pRenderer( pRenderer )
	{
		if( m_pRenderer )
		{
			m_pRenderer->addRefCount();
		}
	
	}

	SceneRoot::~SceneRoot()
	{
		if(m_pRenderer)
		{
			m_pRenderer->dropRefCount();
		}
	}
}
